## Types de base

## vecteur
v1 <- c(1, 2, 3)
v2 <- c("a", "b")
v3 <- c(TRUE, TRUE, FALSE)
v1[2]
v1[1:2]
v1[c(3, 2)]

## matrix
m1 <- matrix(1:12, ncol = 3)
m2 <- matrix(letters[1:12], ncol = 3)
m3 <- matrix(TRUE, ncol = 3, nrow = 2)
m4 <- matrix(c(TRUE, FALSE), ncol = 3, nrow = 2)
m1[1, 2]
m1[1, ]

## data.frame
df1 <- data.frame(x = 1:3,
                  y = LETTERS[1:3],
                  z = c(TRUE, FALSE, FALSE))
df1[2, 2]

## list
l1 <- list(v1, v3, m2, df1)
length(l1)
l1[1:2]
l1[3]   ## list
l1[[3]] ## 3e element of l1


length(l1[3])
length(l1[[3]])

dim(l1[[3]])
dim(l1[3])

class(v1)
class(v2)
class(m1)
class(l1)


## factors
f1 <- factor(c("M", "F", "F", "M"))
f1
class(f1)

## NA
class(c(1, 2, NA, 4))
class(c(v2, NA))

## Function
## 1. name
## 2. input (arguments, parameters)
## 3. body (code de la fonction)
## 4. output (return)
ma_function <- function(x, y) {
  message("1st input:", x)
  message("2nd input:", y)
  z <- abs(x) + y^2
  return(z)
}


class(ma_function)

v1 <- c(10, 15, 1, 12)
v2 <- c(5, 10, 13, 18)

mean(v1[-3])
mean(v2[-1])

v1

mean(v1[-which.min(v1)])
mean(sort(v1)[-1])
(sum(v1) - min(v1))/(length(v1) - 1)

mean(v1[-which.min(v1)])
mean(v2[-which.min(v2)])

## Function  (chap 9.4 WSBIM1207)
## 1. name
## 2. input (arguments, parameters)
## 3. body (code de la fonction)
## 4. output (return)

moy_interros <- function(x) {
  m <- mean(x[-which.min(x)])
  return(m)
}

moy_interros(v1)
moy_interros(v2)

moy_interros(sample(20, replace = TRUE))

moy_interros(c(10, 11, 20))

moy_interros(c(10, 11))
moy_interros(10)

moy_interros(c())


## iteration (chap 9.2 WSBIM1207)
set.seed(1L)
interros <- matrix(sample(20, 1000, replace = TRUE),
                   nrow = 200)
head(interros)

dim(interros)

## 1. appliquer la fonction moy_interros à chaque 
##    ligne de la matrice interros.
moy_interros(interros[1, ])
moy_interros(interros[2, ])
moy_interros(interros[3, ])
## ..
moy_interros(interros[200, ])

## 2. appliquer la fonction moy_interros le long de
##    la 1ere dimension de la matrice interros.

## 3. apply function moy_interros along 
##    dim 1 of interros.

## 4. apply along interros, dim 1, function moy_interros

res <- apply(interros, 1, moy_interros)

length(res)
class(res)

res2 <- apply(interros, 2, moy_interros)

class(res2)
length(res2)


moy_interros_2 <- function(x) {
  m <- mean(x)
  return(m)
}

apply(interros, 2, moy_interros_2)

apply(interros, 2, mean)

colMeans(interros)

## misc

read.csv()
readr::read_csv()

write.csv()
readr::write_csv()

save(interros, file = "interros.rda")
rm(interros)
load("interros.rda")
head(interros)

sessionInfo()








