library(Biostrings)

## ---------------------------
fa_file <-
  system.file(package="Biostrings", "extdata", "dm3_upstream2000.fa.gz")

dna <- readDNAStringSet(fa_file)

subseq(dna, start = 1, end = 100)
subseq(dna, start = 1, width = 100)

## ---------------------------

browseVignettes(package = "MSnbase")
vignette(package = "MSnbase")
vignette("v01-MSnbase-demo", package = "MSnbase")


## ---------------------------

readLines(fa_file, 6)

tail(readLines(fa_file, 1000), 10)

fa <- readLines(fa_file)
length(fa)

head(readLines(fa_file), 5)
tail(readLines(fa_file), 5)

## ---------------------------
library("Biostrings")
library("BSgenome.Dmelanogaster.UCSC.dm2")

IRanges(1, 10)
seqlengths(Dmelanogaster)
seqlengths(Dmelanogaster)["chr2L"]
IRanges(1, seqlengths(Dmelanogaster)["chr2L"])

chr2L_range <- GRanges("chr2L", 
                       IRanges(1, seqlengths(Dmelanogaster)["chr2L"]))
chr2L_range


chr2L_dna <- getSeq(Dmelanogaster, chr2L_range)

print(object.size(chr2L_dna), units = "Mb")

ir <- IRanges(start = 2, end = 5)

test_range <- GRanges("chr2L", 
                       IRanges(start = 2, width = 5))
test_range
x <- getSeq(Dmelanogaster, test_range)

## ---------------------------

ir <- IRanges(start = 2, end = 5)
ir

## ---------------------------

as_tibble
tibble::as_tibble

library(tibble)
as_tibble

filter

library(tidyverse)
filter

stats::filter
dplyr::filter

## ---------------------------

length(dna)
length(nchar(dna))
table(nchar(dna))

## ---------------------------

methods(class = "DNAStringSet")

library(SummarizedExperiment)
methods(class = "SummarizedExperiment")

grep("reverse", methods(class = "DNAStringSet"), value = TRUE)

grep("exprs", methods(class = "MSnSet"))

## ---------------------------

DNAString
DNAStringSet

## ---------------------------

try(error())

## ---------------------------

## Focusing on the region from base 10 million to 11 million along 
## chromosome 2L, calculate the GC content across a sliding window 
## of 5000 nucleotides (you can use the letterFrequencyInSlidingView 
## functionn) and visualise it (see an example below). On that plot, 
## show the mean GC content and highlight the regions that have a GC 
## content > 0.5 and < 0.35.

chr2L_dna[[1]]

x <- subseq(chr2L_dna[[1]], 10 * 1e6, 11 * 1e6)

gc <- letterFrequencyInSlidingView(x, 5000, 
                                   letters = "GC", 
                                   as.prob = TRUE)
head(gc)
class(gc)
dim(gc)

plot(gc, type = "l", main = "Chromosome 2L (10 - 11 Mb)")
abline(h = mean(gc))
abline(v = which(gc > 0.5), col = "#FF0000")
abline(v = which(gc < 0.35), col = "#0000FF")
lines(gc)




