## Questions/reponses

## col/row names
m <- matrix(rnorm(100), 
            ncol = 10, nrow = 10)
m[1:10, 1:5]

colnames(m)

paste0("sample", 1:10)
paste("sample", 1:10, sep = "_")

colnames(m) <- paste("sample", 1:10, sep = "_")
colnames(m)

rownames(m) <- paste("gene", 1:10, sep = "_")

m[1:10, 1:5]


## for loop

cmns <- colMeans(m)
for (i in 1:10)
  m[, i] <- m[, i] - cmns[i]


for (i in 1:10) {
  m[, i] <- m[, i] - cmns[i]
}

## quantiles norm

## hist/barplot

x <- rnorm(100)
hist(x)
hist(x, breaks = 5)
hist(x, breaks = 20)

barplot(x)

table(x)

barplot(table(round(x, 1)))

lt <- sample(letters, 300, replace = TRUE)
barplot(table(lt))


## ex suppl

library(rWSBIM1322)
data("up_selected")
up_selected
length(up_selected)

library(Biostrings)

up <- readAAStringSet("./data/uniprot-proteome_UP000005640_reviewed.fasta.gz")
up

## up <- readAAStringSet("~/Downloads/up.fasta")

up_selected

nm <- names(up)

nm2 <- sub("sp\\|", "", nm)
nm3 <- sub("\\|.+$", "", nm2)

nm[1:3]
nm2[1:3]
nm3[1:3]

sel <- nm3 %in% up_selected
table(sel)

up2 <- up[sel]
up2

## DDVF, DEVF EDVF or EEVF

grep("A", letters)

grep("DDVF", up2)
grep("DEVF", up2)
grep("EDVF", up2)
grep("EEVF", up2)

grep("[DE][DE]VF", up2)



stringr:::str_detect("DDVF", as.character(up2))


## scaling

m2 <- scale(m, center = TRUE, scale = TRUE)
m2[1:10, 1:4]

m2

