## Correction interrogation 2020-11-09

library(rWSBIM1322)
library(SummarizedExperiment)

x <- make_data("123")
x

colData(x)

which(x$group == "CTRL")
## 1 2 6

my_t_test <- function(x) {
  t.test(x[c(1, 2, 6)], x[c(3, 4, 5)])$p.value
}

my_lfc <- function(x) {
  mean(x[c(1, 2, 6)]) - mean(x[c(3, 4, 5)])
}

pv <- apply(assay(x), 1, my_t_test)

lfc <- apply(assay(x), 1, my_lfc)

padj <- p.adjust(pv, method = "BH")

table(padj < 0.05)


plot(lfc, -log10(padj))
grid()
abline(h = -log10(0.05))

rownames(x)

library(Biostrings)

aa <- readAAStringSet("./data/up.fasta.gz")
length(aa)


names(aa) <- sub("\\|.+$", "", sub("sp\\|", "", names(aa)))
aa

de <- names(which(padj < 0.05))
nde <- names(which(padj >= 0.05))

length(grep("LAL", aa[de]))

length(grep("LAL", aa[nde]))
