## clustering

library(rWSBIM1322)

data(giris)



## kmeans

km <- kmeans(giris[, -5], 
             centers = 3,
             nstart = 10)

km
class(km)

km$cluster

library(factoextra)
pca <- prcomp(giris[, -5])
factoextra::fviz_pca_ind(pca, 
                         habillage = km$cluster)


km1 <- kmeans(giris[, -5], 
              centers = 3,
              nstart = 10)

km2 <- kmeans(giris[, -5], 
              centers = 3,
              nstart = 10)

table(km1$cluster, km2$cluster)

km1 <- kmeans(giris[, -5], 
              centers = 3)

km2 <- kmeans(giris[, -5], 
              centers = 3)


table(km1$cluster, km2$cluster)

## hierarchical clustering

head(giris)

d <- dist(giris[, -5])
class(d)

as.matrix(d)[1:5, 1:5]

hcl <- hclust(d)
plot(hcl)

abline(h = 1.5, col = "red")
cl1 <- cutree(hcl, h = 1.5)
table(cl1)

cl2 <- cutree(hcl, k = 3)
table(cl2)


factoextra::fviz_pca_ind(pca, 
                         habillage = cl2)

table(km1$cluster, cl2)


p1 <- factoextra::fviz_pca_ind(pca, 
                         habillage = cl2)

p2 <- factoextra::fviz_pca_ind(pca, 
                               habillage = km1$cluster)
p1 + p2
